#include "widget.h"

Widget::Widget(QWidget *parent)
    : QWidget(parent)
    , m_dragPosFromWidget()
    , m_tracking( false )
{
    setWindowFlag( Qt::FramelessWindowHint );
    setAttribute( Qt::WA_TranslucentBackground );
}

Widget::~Widget()
{

}


void Widget::paintEvent( QPaintEvent* /* p_event */ )
{
    QPainter painter( this );

    painter.fillRect( rect(), QColor(0, 0, 0, 1) );
    painter.setPen( Qt::red );
    painter.drawRect( rect() );
}

void Widget::mousePressEvent( QMouseEvent* p_event )
{
    if( p_event->button() == Qt::LeftButton )
    {
        m_dragPosFromWidget = p_event->globalPos() - geometry().topLeft();
        m_tracking = true;
    }
}

void Widget::mouseMoveEvent( QMouseEvent* p_event )
{
    if( m_tracking )
    {
        QPoint newWindowPos = p_event->globalPos() - m_dragPosFromWidget;
        move( newWindowPos );
    }
}

void Widget::mouseReleaseEvent( QMouseEvent* p_event )
{
    m_dragPosFromWidget = QPoint();
    m_tracking = false;
}

